<?php

require_once "exForm/Form.php";

class ItemEditForm extends exActionFormEx
{
	var $itemid_;
	var $itemname_;
	var $itemdesc_;
	var $formtype_;
	var $formmax_;
	var $formlength_;
	var $formdefault_;
	var $formoptions_;
	var $tablename_ ;
	var $weight_ ;
	var $visible_l ;
	var $visible_e ;
	
	function fetch(&$master,&$request) {
        parent::fetch($master,$request);
		$this->itemid_ = intval($request->Params_['itemid']);
		if( isset($this->itemid) && !$this->itemid_ && intval($this->itemid)!==0) {
			$this->addError(_MD_A_ADDBOOK_ERROR_ITEMID_REQUIRED);
		}		

        $this->itemname_ = trim($request->Params_['itemname']);
		if(!$this->itemname_) {
			$this->addError(_MD_A_ADDBOOK_ERROR_ITEMNAME_REQUIRED);
		}elseif( preg_match('/^[ ]*$/', $this->itemname_)) {
			$this->addError(_MD_A_ADDBOOK_ERROR_ITEMNAME_REQUIRED);
		}
		if(!$this->validateMaxLength($this->itemname_, 255)) {
			$this->addError(_MD_A_ADDBOOK_ERROR_ITEMNAME_SIZEOVER);
		}

		$this->formtype_ = $request->Params_['formtype'];
		if(!$this->validateMaxLength($this->formtype_, 255)) {
			$this->addError(_MD_A_ADDBOOK_ERROR_FORMTYPE_SIZEOVER);
		}

		if(function_exists('mb_convert_kana')){
			$this->formmax_ = mb_convert_kana($request->Params_['formmax'], 'a', _CHARSET);
		}else{
			$this->formmax_ = $request->Params_['formmax'];	
		}
		$this->formmax_ = intval($this->formmax_);

		if(function_exists('mb_convert_kana')){
			$this->formlength_ = mb_convert_kana($request->Params_['formlength'], 'a', _CHARSET);
		}else{
			$this->formlength_ = $request->Params_['formlength'];	
		}
		$this->formlength_ = intval($this->formlength_);
		if(!$this->validateMaxLength($this->formlength_, 10)) {
			$this->addError(_MD_A_ADDBOOK_ERROR_FORMLENGTH_SIZEOVER);
		}

		$this->formdefault_ = $request->Params_['formdefault'];
		if(!$this->validateMaxLength($this->formdefault_, 255)) {
			$this->addError(_MD_A_ADDBOOK_ERROR_FORMDEFAULT_SIZEOVER);
		}

		$this->formoptions_ = $request->Params_['formoptions'];
		$this->itemdesc_ = $request->Params_['itemdesc'];

		$this->tablename_ = $request->Params_['tablename'];
		if(!$this->tablename_) {
			$this->addError(_MD_A_ADDBOOK_ERROR_TABLENAME_REQUIRED);
		}

		$this->weight_ = intval($request->Params_['weight']);
		$this->visible_l_ = intval($request->Params_['visible_l']);
		$this->visible_e_ = intval($request->Params_['visible_e']);
		
	}

	function load(&$master,&$request) {
		$this->itemid_=$master->getVar('itemid', 'e');
		$this->itemname_=$master->getVar('itemname', 'e');
		$this->itemdesc_=$master->getVar('itemdesc', 'e');
		$this->formtype_=$master->getVar('formtype', 'e');
		$this->formmax_=$master->getVar('formmax', 'e');
		$this->formlength_=$master->getVar('formlength', 'e');
		$this->formdefault_=$master->getVar('formdefault', 'e');
		$this->formoptions_=$master->getVar('formoptions', 'e');
		$this->tablename_=$master->getVar('tablename', 'e');
		$this->weight_=$master->getVar('weight', 'e');
		$this->visible_l_ = $master->getVar('visible_l','e');
		$this->visible_e_ = $master->getVar('visible_e','e');
	}

	function update(&$master) {
//		$master->setVar('itemid', $this->itemid_);
		$master->setVar('itemname', $this->itemname_);
		$master->setVar('itemdesc', $this->itemdesc_);
		$master->setVar('formtype', $this->formtype_);
		$master->setVar('formmax', $this->formmax_);
		$master->setVar('formlength', $this->formlength_);
		$master->setVar('formdefault', $this->formdefault_);
		$master->setVar('formoptions', $this->formoptions_);
		$master->setVar('tablename', $this->tablename_);
		$master->setVar('weight', $this->weight_);
		$master->setVar('visible_l', $this->visible_l_);
		$master->setVar('visible_e', $this->visible_e_);
	}
}


?>