<?php
/**
@file
@brief exDynaActionForm ѤΥեɥץѥƥ˴ؤ륯饹Ƥե
@author minahito
@version $Id$

\section copyright Copyright and license
 Copyright (c) 2003-2004, minahito
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

1 Redistributions of source code must retain the above copyright notice, 
  this list of conditions and the following disclaimer.

2 Redistributions in binary form must reproduce the above copyright notice, 
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

3 Neither the name of the nor the names of its contributors may be used to 
  endorse or promote products derived from this software without specific 
  prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
 WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 SUCH DAMAGE.
*/

/**
@brief Ϳ줿 EXDA_FTYPE 򸵤˥饹᤹
*/
class exDynaActionFormPropertyFactory
{
	/**
	@brief Ϳ줿 EXDA_FTYPE_XXXX 򸵤ˡб exDynaActionFormFieldProperty Ѿ饹᤹
	@note Υ᥽åɤ 0.90.4 ޤǤ switch ȤäƤޤ
	      0.90.5 ʹߤǤ̿̾ѥˤäƥ饹̾饹ä˥󥹥󥹤᤹ΤѹƤޤ
	      ̿̾§
	      \code
	      "exDynaActionForm".ucfirst(strtolower($name))."Property"
	      \endcode
	      Ǥ
	@param $name string
	@return exDynaActionFormProperty
	*/
	function &create($name)
	{
		$ret = null;
		if(preg_match("/\[\]$/",$name))
			$classname = "exDynaActionForm".ucfirst(strtolower($name))."ArrayProperty";
		else
			$classname = "exDynaActionForm".ucfirst(strtolower($name))."Property";

		if(class_exists($classname))
			$ret = new $classname();
		else {
			die ( $name." Property is not exist" );
		}

		return $ret;
	}
}

/**
@brief եɥץѥƥ򤷤᤹ȥ饯㡼
*/
class exDynaActionFormProperty
{
	var $name_;					///< ץѥƥ̾Ρ̾ΤǥꥯȤͤ fetch ߤޤ
	var $type_ = EXDA_FTYPE_NULL;	///< ץѥƥη
	var $value_ = null;			///< ץѥƥ
	var $fetch_ = true;			///< Υեɥץѥƥͤ exDynaActionForm::fetch() νоݤȤ뤫ɤǤ
	var $update_ = true;			///< Υեɥץѥƥͤ exDynaActionForm::update() νоݤȤ뤫ɤǤ
	var $load_ = true;			///< Υեɥץѥƥͤ exDynaActionForm::load() νоݤȤ뤫ɤǤ

	/**
	@brief ʬηФŬڤʥꥯȤФԤͤvalue_ץѥƥ˳Ǽޤ
	@brief $request exHttpRequest
	*/
	function fetch(&$request)
	{
	}
}

/**
@brief EXDA_FTYPE_INT ݻեɥץѥƥ
*/
class exDynaActionFormIntProperty extends exDynaActionFormProperty
{
	function exDynaActionFormIntProperty()
	{
		$this->type_ = EXDA_FTYPE_INT;
	}

	function fetch(&$request)
	{
		// print "AsInteger ǥեå\n";
		$this->value_ = $request->getParamsAsInteger($this->name_);
	}
}

/**
@brief EXDA_FTYPE_INT ݻ뤬fetchboolȽꤹեץѥƥ
*/
class exDynaActionFormBoolProperty extends exDynaActionFormProperty
{
	function exDynaActionFormBoolProperty()
	{
		$this->type_ = EXDA_FTYPE_INT;
	}

	function fetch(&$request)
	{
		$this->value_ = $request->getParamsAsInteger($this->name_) ? 1 : 0;
	}
}

/**
@brief EXDA_FTYPE_INT_ARRAY ݻեɥץѥƥ
*/
class exDynaActionFormIntArrayProperty extends exDynaActionFormProperty
{
	function exDynaActionFormIntArrayProperty()
	{
		$this->type_ = EXDA_FTYPE_INT_ARRAY;
		$this->value_=array();
	}

	function fetch(&$request)
	{
		$value = $request->getParams($this->name_);
		if(is_array($value)) {
			foreach($value as $key=>$val)
				$this->value_[$key]=$val;
		}
		else {
			$this->value_[]=intval($value);
		}
	}
}


/**
@brief EXDA_FTYPE_STRING ݻեɥץѥƥ
*/
class exDynaActionFormStringProperty extends exDynaActionFormProperty
{
	function exDynaActionFormStringProperty()
	{
		$this->type_ = EXDA_FTYPE_STRING;
	}

	function fetch(&$request)
	{
		// print "AsText ǥեå\n";
		$this->value_ = $request->getParamsAsText($this->name_);
	}
}

/**
@brief EXDA_FTYPE_STRING ݻեɥץѥƥ
*/
class exDynaActionFormStringArrayProperty extends exDynaActionFormProperty
{
	function exDynaActionFormStringArrayProperty()
	{
		$this->type_ = EXDA_FTYPE_STRING_ARRAY;
		$this->value_ = array();
	}

	function fetch(&$request)
	{
		$value = $request->getParams($this->name_);
		if(is_array($value)) {
			foreach($value as $key=>$val)
				$this->value_[$key]=$this->value_[]=$myts->stripSlashesGPC($val);
		}
		else {
			// ľ
			$this->value_[]=$request->getParamsAsText($this->name_);
		}
	}
}

/**
@brief EXDA_FTYPE_FILE ݻեɥץѥƥ
*/
class exDynaActionFormFileProperty extends exDynaActionFormProperty
{
	function exDynaActionFormFileProperty()
	{
		$this->type_ = EXDA_FTYPE_FILE;
	}

	function fetch(&$request)
	{
		// print "FILE եå\n";
		$this->value_ = isset($request->Files_[$this->name_]) ? $request->Files_[$this->name_] : null;
	}
}

/**
@brief XoopsFormDate ΥꥯȤ fetch  unixtime ͤȤݻեץѥƥ
@note Υեץѥƥϡꤵ줿ץѥƥ̾ΥꥯȤ exFrame::decodeXoopsFormDate() ̤Ƽޤ
*/
class exDynaActionFormXoopsformdateProperty extends exDynaActionFormProperty
{
	function exDynaActionFormFileProperty()
	{
		$this->type_ = EXDA_FTYPE_INT;
	}

	function fetch(&$request)
	{
		$this->value_ = intval(exFrame::decodeXoopsFormDate($request->getParams($this->name_)));
	}
}

/**
@brief XoopsFormDateTime ΥꥯȤ fetch  unixtime ͤȤݻեץѥƥ
@note Υեץѥƥϡꤵ줿ץѥƥ̾ΥꥯȤ exFrame::decodeXoopsFormDate() ̤Ƽޤ
*/
class exDynaActionFormXoopsformdatetimeProperty extends exDynaActionFormProperty
{
	function exDynaActionFormXoopsformdatetimeProperty()
	{
		$this->type_ = EXDA_FTYPE_INT;
	}

	function fetch(&$request)
	{
		$this->value_ = intval(exFrame::decodeXoopsFormDateTime($request->getParams($this->name_)));
	}
}

/**
@brief եåꥯȤ򸫤ΤǤϤʤ time() ͤüʥץѥƥͤȤƤ unixtime ݻ int ˤʤޤ
*/
class exDynaActionFormNowtimeProperty extends exDynaActionFormProperty
{
	function exDynaActionFormFileProperty()
	{
		$this->type_ = EXDA_FTYPE_INT;
	}

	function fetch(&$request)
	{
		$this->value_ = time();
	}
}

/**
@brief եåꥯȤ򸫤ΤǤϤʤƥ֥桼 uid ͤüʥץѥƥͤȤƤ int ˤʤޤ
*/
class exDynaActionFormCurrentuidProperty extends exDynaActionFormProperty
{
	function exDynaActionFormFileProperty()
	{
		$this->type_ = EXDA_FTYPE_INT;
	}

	function fetch(&$request)
	{
		global $xoopsUser;
		if(is_object($xoopsUser))
			$this->value_ = $xoopsUser->getVar('uid');
		else
			$this->value_ = 0;
	}
}

?>