<?php
/**
@file
@version $Id: Form.php,v 1.16 2005/09/14 16:37:48 minahito Exp $
*/

define ( "ACTIONFORM_INIT_FAIL", '__error__actionform_init_fail__' );
define ( "ACTIONFORM_INIT_SUCCESS", '__actionform_init_success__' );
define ( "ACTIONFORM_POST_SUCCESS", '__actionform_post_success__' );

/**
@brief 
@note exAbstractForm Ⱥ礹ǽ礤ˤΤǤĥʤǲ
*/
class exAbstractFormObject {
	var $msg_;				///< 顼åХåե
	var $err_render_=null;	///< 顼å󥰤 exFormErrorRender 饹Υ󥹥󥹤ݻ

	function exAbstractFormObject() {
		$this->msg_=array();
		$this->err_render_=new exFormErrorRender();
	}

	/**
	@brief $msg 򥨥顼åХåեɲä
	@param $msg 顼åʸ
	@return ʤ
	*/
	function addError($msg) {
		$this->msg_[]=$msg;
	}

	/**
	@brief 顼åХåե˥åϿ뤫ɤĴ٤ޤ
	@return 顼å true ʤ false ֤ޤ
	*/
	function isError() {
		return count($this->msg_);
	}

	/**
	@brief 顼åʸ֤ޤ
	@return string
	*/
	function getHtmlErrors() {
		$this->err_render_->init($this);
		return $this->err_render_->render();
	}
}

/**
@brief ( AbstractBase)
@deprecated  XoopsObject ȤϢȤ˥ǥ󤵤줿ե侩Ǥ
ۤƱͤưԤ exAbstractActionFormEx إ饹ȤƻѤǤޤ
Υ饹ϲΥݡͥȤΰܹԤޤǤδ֤ϻĤޤŪˤϺޤ
*/
class exAbstractForm extends exAbstractFormObject {
	var $data_;	///< ᥽åɤϤ줿󥹥󥹤򥭡פ
	
	function init($data=null) {
		if($data) {
			$this->data_=&$data;
		}
		if($_SERVER['REQUEST_METHOD']=='POST') {
			$this->doPost($data);
			return count($this->msg_) ? ACTIONFORM_INIT_FAIL : ACTIONFORM_POST_SUCCESS;
		}
		elseif($_SERVER['REQUEST_METHOD']=='GET') {
			$this->doGet($data);
			return count($this->msg_) ? ACTIONFORM_INIT_FAIL : ACTIONFORM_INIT_SUCCESS;
		}
		else {
			return ACTIONFORM_INIT_FAIL;
		}
		
	}

	function doGet($data) { }

	function doPost($data) { }

	function initSelf() {
		$dmy=null;
		return $this->init($dmy);
	}
}

class exAbstractActionForm extends exAbstractForm {
	/**
	@biref  numValue  min  max ϰϤ˼ޤäƤ뤫򸡺ޤ
	@param $numValue оݤȤʤ
	@param $min ϰϤκǾ
	@param $max ϰϤκ
	@return bool min ʲ max ʾǤ true Ǥʤ false ᤷޤ
	*/
	function validateInRange($numValue,$min,$max) {
		return ($numValue>=$min && $numValue<=$max);
	}

	/**
	@brief ʸ string ʸ max ʸʲޤ
	@param $string оݤʸ
	@param $max ꤹʸκ
	@return bool ʸ˼ޤäƤ true Ǥʤ false ޤ
	*/
	function validateMaxLength($string,$max) {
		return (strlen($string)<=$max);
	}

	/**
	@brief ʸ string ʸ min ʸʾ夫ޤ
	@param $string оݤʸ
	@param $max ꤹʸκǾ
	@return bool ʸʾ夢 true Ǥʤ false ޤ
	*/
	function validateMinLength($string,$min) {
		return (strlen($string)>=$min);
	}

	function validateInteger($value) {
		return is_int($value);
	}

	function validatePositive($value) {
		return (intval($value)>0);
	}

	function validateHttpUrl($value) {
		return (strpos($value,"http://")===0 or strpos($value,"https://")===0);
	}
	
	/**
	@brief exFormFile ֥ȤǤ $formfile γĥҤ $extensions ǻꤷĥҤ˴ޤޤƤ true ֤
	@param $formfile exFormFile
	@param $extensions array
	@return boolean
	*/
	function validateExtension($formfile,$extensions)
	{
		if(!is_object($formfile))
			return false;

		$my_ext = strtolower($formfile->getExtension());
		if(is_array($extensions)) {
    		foreach($extensions as $ext) {
    			if($my_ext == strtolower($ext))
    				return true;
    		}
		}
		else
			return $my_ext == strtolower($extensions);
	}

	function validateEmailAddress($email)
	{
		return (preg_match('/^[a-z0-9\-\._]+@[a-z0-9]([0-9a-z\-]*[a-z0-9]\.){1,}[a-z]{1,4}$/i',$email));
	}

	/**
	@brief exFormFile ֥ȤǤ $formfile Υե륵 $maxsize ǻꤷХȿ˼ޤäƤп֤ޤ
	@param $formfile exFormFile
	@param $maxsize int
	@return boolean
	*/
	function validateMaxFilesize($formfile,$maxsize)
	{
		if(!is_object($formfile))
			return false;
			
		return $formfile->getFileSize()<=$maxsize;
	}

	function getPositive($value) {
		$ret=intval($value);
		if($ret<=0)
			return 0;
		else
			return $ret;
	}
}

/**
@brief Ūʥե
@todo exAbstractFormObject δڤؤ
*/
class exActionForm extends exAbstractActionForm {
	/**
	@brief ΥեꥯȤ˱Ƽ¹Ԥ
	ActionForm  POST ꥯȻΤߤ fetch Ԥ
	mojaLE Ȥ䤹뤿 load/doGet ȤϢưϹԤʤ
	@return ACTIONFORM_XXXX
	@note ͤˤĤ
		POST ꥯȻfetch ꤬ȯ ACTIONFORM_INIT_FAIL 
		꤬ȯʤ ACTIONFORM_POST_SUCCESS ֤ޤ
		POST ꥯȰʳξ ACTIONFORM_INIT_SUCCESS ֤ޤ
	*/
	function init($master) {
		if($_SERVER['REQUEST_METHOD']=='POST') {
			$this->fetch();
			return count($this->msg_) ? ACTIONFORM_INIT_FAIL : ACTIONFORM_POST_SUCCESS;
		}
		else {
			return ACTIONFORM_INIT_SUCCESS;
		}
	}

	/**
	@brief ꥯȤʤɤǡФե˥ǡή
	*/
	function fetch() {
	}

	/**
	@brief Ϥ줿ޥǡ餳ΥեΥФۤ
	@param $master ǡ
	*/
	function load(&$master) {
	}

	/**
	@brief Ϥ줿ޥǡˤΥեξϤ
	@param $master ǡ
	*/
	function update(&$master) {
	}
}

/**
@brief GET/POST ư˱Ƶưѹ륢ե
Υեϡ GET ꥯȤκݤ load ᥽åɤPOST ꥯȤκݤ fetch ᥽åɤ
¹Ԥޤ
\par Υե mojaLE ¦ GET/POST ڤʬԤʤ硢mojaLE Ȥʤˡ
ץե졼Ūʵư򤷤ޤΤǤ
*/
class exActionFormEx extends exAbstractActionForm {
	/**
	@brief ΥեꥯȤ˱Ƽ¹Ԥ롣
	\par ActionForm  POST ꥯȻΤߤ fetch Ԥ
	exAbstractActionForm Ȱۤʤ GET ꥯȤκݤˤ load Ԥ
	\par mojaLE ʤ GET/POST Ȥʬ Action ʻѤ exAbstractActionForm Ѥ٤Ǥ
	@param $master fetch  load ؤΰ
	@param $request exAbstractHttpRequest
	@return POST ꥯȻfetch ꤬ȯ ACTIONFORM_INIT_FAIL 
			꤬ȯʤ ACTIONFORM_POST_SUCCESS ֤ޤ
			\par GET ꥯȻload ꤬ȯ ACTIONFORM_INIT_FAIL 
			꤬ȯʤ ACTIONFORM_INIT_FAIL ֤ޤ
	*/
	function init(&$master,&$request) {
		if($_SERVER['REQUEST_METHOD']=='POST') {
			$this->fetch($master,$request);
			return count($this->msg_) ? ACTIONFORM_INIT_FAIL : ACTIONFORM_POST_SUCCESS;
		}
		else {
			$this->load($master,$request);
			return count($this->msg_) ? ACTIONFORM_INIT_FAIL : ACTIONFORM_INIT_SUCCESS;
		}
	}

	function fetch(&$master,$request)
	{
		$this->load($master,$request);
	}
	
	function load(&$master,&$request)
	{
	}
}


/**
@brief AbstractForm ϤΥ󥹥󥹤ץѥƥ msg Ѥåɽ
ʤ󶡤 class
\par exAbstractFormObject  getHtmlErrors ᥽åɤ뤵줿ȤΥ饹
render ᥽åɤƤӽФޤ
\par Υ饹ɸ exAbstractFormObject ȤѤ顼ɤ <li> 
֤ʸȤäƥ󥰤ޤ
\par 顼åɽưѤȤưѹ뤳ȤҤȤĤˡ
ʤޤܤ exAbstractFormObject  $err_render_ Ф򸫤Ƥ
*/
class exFormErrorRender {
	var $form_=null;

	function init($form) {
		$this->form_=$form;
	}

	function render() {
		$ret ="<ul>";
		foreach($this->form_->msg_ as $m) {
			$ret.=@sprintf("<li><font color='red'>%s</font></li>\n",$m);
		}
		$ret .="</ul>";
		return $ret;
	}
}

?>