<?php

class exTestOutput
{
	var $m_suite_;
	var $m_resultBuf_;
	
	function setSuite(&$suite)
	{
		$this->m_suite_=&$suite;
	}
	
	function generate()
	{
	}

	function display()
	{
		print $this->m_resultBuf_;
	}
}

class exTestOutputConsoleHtml extends exTestOutput
{
	function generate()
	{
		foreach($this->m_suite_->m_suites_ as $suite) {
			
			$correctPer=intval($suite->total_success()/$suite->total_test() * 100);

			$this->m_resultBuf_ .= sprintf("<br/>\n%s: %d/%d, %d%% correct<br/>\n",
							$suite->getSuiteName(),
							$suite->total_test(),		// FIXME
							$suite->total_test(),$correctPer);

			foreach($suite->m_assertments_ as $assert) {
				$outputString="";

				$outputString.="\n";
				$outputString.="    Test:    ".$assert->m_testName_."\n";
				$outputString.="    Suite:   ".$assert->m_suiteName_."\n";
				if($assert->m_file_)
					$outputString.="    File:    ".$assert->m_file_."\n";
				if($assert->m_line_)
					$outputString.="    Line:    ".$assert->m_line_."\n";
				if($assert->m_message_)
					$outputString.="    Message: ".$assert->m_message_."\n";

				$this->m_resultBuf_ .= nl2br(str_replace(" ","&nbsp;",$outputString));
			}
			$this->m_resultBuf_ .= "<img src='".XOOPS_URL."/modules/exFrame/images/help.png' width='".$correctPer."' height='20' />";
		}
	}
}

/**
@todo ľ
*/
class exTestOutputXoops extends exTestOutput
{
	function generateSummary()
	{
		$countTest = $this->m_suite_->getCountTotalTest();
		$countError = $this->m_suite_->getCountTotalErrorTest();
		$totalPer = $this->m_suite_->getTotalSuccessPer();

		$style="";
		if($totalPer!=100)
			$style="style='color: #ff0000; font-weight: bold;'";

		$returnBuf= "<h2 id='top'>Summary</h2>".
					"<table class='outer' cellspacing='1'>".
					"<tr><th>Test</th><th>Errors</th><th>Success</th></tr>".
					"<tr class='odd' $style><td>$countTest</td><td>$countError</td><td>$totalPer%</td></tr>".
					"</table>";

		return $returnBuf;
	}

	function generateTestSuites()
	{
		$returnBuf= "<h2>Test Suites</h2>".
					"<table class='outer' cellspacing='1'>".
					"<tr><th>Name</th><th>Tests</th><th>Errors</th><th>Success</th></tr>";
		foreach($this->m_suite_->m_suites_ as $suite) {
			$style="";
			if($suite->m_countError_)
				$style="style='color: #ff0000; font-weight: bold;'";

			$returnBuf.="<tr class='odd'><td><a href='#".$suite->getSuiteName()."'>".$suite->getSuiteName()."</a></td>".
						"<td $style>".$suite->total_test()."</td>".
						"<td $style>".$suite->m_countError_."</td>".
						"<td $style>".$suite->getSuccessPer()."%</td></tr>";
		}
		$returnBuf.="</table>";
		
		return $returnBuf;
	}
	
	function generateSuiteInfomation()
	{
		$suiteInfoBuf="";
		foreach($this->m_suite_->m_suites_ as $suite) {
			$correctPer=intval($suite->total_success()/$suite->total_test() * 100);

			$suiteInfoBuf.="<h3 id='".$suite->getSuiteName()."'>Suite : ".$suite->getSuiteName()."</h3>";

			$suiteInfoBuf.="<table class='outer' cellspacing='1'>".
							 "<tr>".
							 "<th>Name</th><th>Error</th><th>Success</th>".
							 "</tr>";
			// ƥ̾
			foreach($suite->m_tests_ as $test) {
				$testName = $test->m_name_;
				$style="";
				if($test->m_countError_) {
					$style="style='color: #ff0000; font-weight: bold;'";
					$testName="<a href='#".$suite->getSuiteName()."_".$test->m_name_."'>".$testName."</a>";
				}

				$suiteInfoBuf.="<tr><td class='odd'>".$testName."</td>";
				$suiteInfoBuf.="<td class='odd' $style>".$test->m_countError_."</td>";
				$suiteInfoBuf.="<td class='odd' $style>".($test->m_countError_ ? "false" : "true")."</td></tr>";
			}
			$suiteInfoBuf.="</table>";
			$suiteInfoBuf.="<p><a href='#top'>Back to top</a></p>";
		}
		
		return $suiteInfoBuf;
	}

	function generateResults()
	{
		$checkMap=array();
		$returnString="<h2>Test Results</h2>";
		foreach($this->m_suite_->m_suites_ as $suite) {

			$displayedStatementFlag=false;

			foreach($suite->m_tests_ as $test) {
				$id = $suite->getSuiteName()."_".$test->getName();
				$returnString .= "<div id='$id'>";

				if($test->m_assertments_) {
					foreach($test->m_assertments_ as $assert) {
						$displayedStatementFlag=true;
						$returnString.="<table class='outer' cellspacing='1' $id>";
						$returnString.="<tr><td	class='head'>Test</td><td class='odd'>".$assert->m_suiteName_."::".$assert->m_testName_."</td></tr>";
						if($assert->m_file_ && $assert->m_line_)
							$returnString.="<tr><td	class='head'>File</td><td class='odd'>".$assert->m_file_.":".$assert->m_line_."</td></tr>";
						if($assert->m_message_)
							$returnString.="<tr><td	class='head'>Message</td><td class='odd'>".$assert->m_message_."</td></tr>";
	
						$returnString.="</table><br/>";
					}
				}
				$returnString .= "</div>";
			}
			
			if($displayedStatementFlag) {
				$suiteName=$suite->getSuiteName();
				$returnString .= "<p><a href='#$suiteName'>Back to $suiteName</a></p>";
			}
		}

		return $returnString;
	}
	
	function generate()
	{
		$this->m_resultBuf_ = $this->generateSummary()."<hr/>".
							$this->generateTestSuites()."<hr/>".
							$this->generateSuiteInfomation()."<hr/>".
							$this->generateResults();
	}
}

?>