<?php

class CriteriaCompoEx extends CriteriaCompo
{
	var $ex_state_;
	var $renderer_;

	var $sorts_;

    function CriteriaCompoEx($element=null, $cond='AND')
    {
    	parent::CriteriaCompo($element, $cond);
    	if(is_object($element)) {
    		$this->add($element,$cond);
    	}
    	$this->renderer_ = new CriteriaExRenderer4Sql();
    	$this->ex_state_ = new CriteriaExState();
    }
    
    function isSort() {
    	return $this->ex_state_->isSort($this);
    }

    function addSort($sort,$order='ASC') {
    	$this->ex_state_->addSort($this,$sort,$order);
    }

    function resetSort() {
    	$this->ex_state_->resetSort($this);
    }

    function renderSort() {
    	return $this->ex_state_->renderSort($this);
    }
}

class CriteriaEx extends Criteria
{
	var $ex_state_;
	var $renderer_;

	var $sorts_;

    function CriteriaEx($column, $value='', $operator='=', $prefix = '', $function = '')
    {
    	parent::Criteria($column, $value, $operator, $prefix, $function);
    	$this->renderer_ = new CriteriaExRenderer4Sql();
    	$this->ex_state_ = new CriteriaExState();
    }
    
    function isSort() {
    	return $this->ex_state_->isSort($this);
    }

    function addSort($sort,$order='ASC') {
    	$this->ex_state_->addSort($this,$sort,$order);
    }

    function resetSort() {
    	$this->ex_state_->resetSort($this);
    }

    function renderSort() {
    	return $this->ex_state_->renderSort($this);
    }
}

class CriteriaExState
{
	function addSort(&$master,$sort,$order='ASC')
	{
		$master->sorts_[] = array(
			'sort'	=>$sort,
			'order'	=>$order
		);
	}
	
	function isSort(&$master)
	{
		return count($master->sorts_) ? true : false;
	}
	
	function resetSort(&$master)
	{
		$master->sorts_ = array();
	}
	
	function renderSort(&$master)
	{
		return $master->renderer_->render($master);
	}
}

/**
@brief ɸSQLѤΥ
*/
class CriteriaExRenderer4Sql
{
	function render(&$criteria)
	{
		$ret="ORDER BY ";
		$tmp = array();
		foreach($criteria->sorts_ as $sort)
		{
			$tmp[] = $sort['sort']." ".$sort['order'];
		}
		
		$ret .= join(",", $tmp);
		return $ret;
	}
}

?>